import numpy as np


np_index_exp_params = [
    np.index_exp[:],
    np.index_exp[...],
    np.index_exp[0],
    np.index_exp[1],
    np.index_exp[-1],
    np.index_exp[-2],
    np.index_exp[0, :],
    np.index_exp[1, :],
    np.index_exp[-1, :],
    np.index_exp[-2, :],
    np.index_exp[0, ...],
    np.index_exp[1, ...],
    np.index_exp[-1, ...],
    np.index_exp[-2, ...],
    np.index_exp[0, 0],
    np.index_exp[1, 0],
    np.index_exp[-1, 0],
    np.index_exp[-2, 0],
    np.index_exp[0, 1],
    np.index_exp[1, 1],
    np.index_exp[-1, 1],
    np.index_exp[-2, 1],
    np.index_exp[0, -1],
    np.index_exp[1, -1],
    np.index_exp[-1, -1],
    np.index_exp[-2, -1],
    np.index_exp[0, -2],
    np.index_exp[1, -2],
    np.index_exp[-1, -2],
    np.index_exp[-2, -2],
    np.index_exp[0, 0, :],
    np.index_exp[1, 0, :],
    np.index_exp[-1, 0, :],
    np.index_exp[-2, 0, :],
    np.index_exp[0, 1, :],
    np.index_exp[1, 1, :],
    np.index_exp[-1, 1, :],
    np.index_exp[-2, 1, :],
    np.index_exp[0, -1, :],
    np.index_exp[1, -1, :],
    np.index_exp[-1, -1, :],
    np.index_exp[-2, -1, :],
    np.index_exp[0, -2, :],
    np.index_exp[1, -2, :],
    np.index_exp[-1, -2, :],
    np.index_exp[-2, -2, :],
    np.index_exp[0, 0, ...],
    np.index_exp[1, 0, ...],
    np.index_exp[-1, 0, ...],
    np.index_exp[-2, 0, ...],
    np.index_exp[0, 1, ...],
    np.index_exp[1, 1, ...],
    np.index_exp[-1, 1, ...],
    np.index_exp[-2, 1, ...],
    np.index_exp[0, -1, ...],
    np.index_exp[1, -1, ...],
    np.index_exp[-1, -1, ...],
    np.index_exp[-2, -1, ...],
    np.index_exp[0, -2, ...],
    np.index_exp[1, -2, ...],
    np.index_exp[-1, -2, ...],
    np.index_exp[-2, -2, ...],
    np.index_exp[0, 0, 0],
    np.index_exp[1, 0, 0],
    np.index_exp[-1, 0, 0],
    np.index_exp[-2, 0, 0],
    np.index_exp[0, 1, 0],
    np.index_exp[1, 1, 0],
    np.index_exp[-1, 1, 0],
    np.index_exp[-2, 1, 0],
    np.index_exp[0, -1, 0],
    np.index_exp[1, -1, 0],
    np.index_exp[-1, -1, 0],
    np.index_exp[-2, -1, 0],
    np.index_exp[0, -2, 0],
    np.index_exp[1, -2, 0],
    np.index_exp[-1, -2, 0],
    np.index_exp[-2, -2, 0],
    np.index_exp[0, 0, 1],
    np.index_exp[1, 0, 1],
    np.index_exp[-1, 0, 1],
    np.index_exp[-2, 0, 1],
    np.index_exp[0, 1, 1],
    np.index_exp[1, 1, 1],
    np.index_exp[-1, 1, 1],
    np.index_exp[-2, 1, 1],
    np.index_exp[0, -1, 1],
    np.index_exp[1, -1, 1],
    np.index_exp[-1, -1, 1],
    np.index_exp[-2, -1, 1],
    np.index_exp[0, -2, 1],
    np.index_exp[1, -2, 1],
    np.index_exp[-1, -2, 1],
    np.index_exp[-2, -2, 1],
    np.index_exp[0, 0, -1],
    np.index_exp[1, 0, -1],
    np.index_exp[-1, 0, -1],
    np.index_exp[-2, 0, -1],
    np.index_exp[0, 1, -1],
    np.index_exp[1, 1, -1],
    np.index_exp[-1, 1, -1],
    np.index_exp[-2, 1, -1],
    np.index_exp[0, -1, -1],
    np.index_exp[1, -1, -1],
    np.index_exp[-1, -1, -1],
    np.index_exp[-2, -1, -1],
    np.index_exp[0, -2, -1],
    np.index_exp[1, -2, -1],
    np.index_exp[-1, -2, -1],
    np.index_exp[-2, -2, -1],
    np.index_exp[0, 0, -2],
    np.index_exp[1, 0, -2],
    np.index_exp[-1, 0, -2],
    np.index_exp[-2, 0, -2],
    np.index_exp[0, 1, -2],
    np.index_exp[1, 1, -2],
    np.index_exp[-1, 1, -2],
    np.index_exp[-2, 1, -2],
    np.index_exp[0, -1, -2],
    np.index_exp[1, -1, -2],
    np.index_exp[-1, -1, -2],
    np.index_exp[-2, -1, -2],
    np.index_exp[0, -2, -2],
    np.index_exp[1, -2, -2],
    np.index_exp[-1, -2, -2],
    np.index_exp[-2, -2, -2],
    np.index_exp[0:1, :],
    np.index_exp[1:, :],
    np.index_exp[-1:, :],
    np.index_exp[-2:, :],
    np.index_exp[0:1, ...],
    np.index_exp[1:, ...],
    np.index_exp[-1:, ...],
    np.index_exp[-2:, ...],
    np.index_exp[0:, 0:],
    np.index_exp[1:, 0:],
    np.index_exp[-1:, 0:],
    np.index_exp[-2:, 0:],
    np.index_exp[0:, 1:],
    np.index_exp[1:, 1:],
    np.index_exp[-1:, 1:],
    np.index_exp[-2:, 1:],
    np.index_exp[0:, -1:],
    np.index_exp[1:, -1:],
    np.index_exp[-1:, -1:],
    np.index_exp[-2:, -1:],
    np.index_exp[0:, -2:],
    np.index_exp[1:, -2:],
    np.index_exp[-1:, -2:],
    np.index_exp[-2:, -2:],
    np.index_exp[0:, 0:, :],
    np.index_exp[1:, 0:, :],
    np.index_exp[-1:, 0:, :],
    np.index_exp[-2:, 0:, :],
    np.index_exp[0:, 1:, :],
    np.index_exp[1:, 1:, :],
    np.index_exp[-1:, 1:, :],
    np.index_exp[-2:, 1:, :],
    np.index_exp[0:, -1:, :],
    np.index_exp[1:, -1:, :],
    np.index_exp[-1:, -1:, :],
    np.index_exp[-2:, -1:, :],
    np.index_exp[0:, -2:, :],
    np.index_exp[1:, -2:, :],
    np.index_exp[-1:, -2:, :],
    np.index_exp[-2:, -2:, :],
    np.index_exp[0:, 0:, ...],
    np.index_exp[1:, 0:, ...],
    np.index_exp[-1:, 0:, ...],
    np.index_exp[-2:, 0:, ...],
    np.index_exp[0:, 1:, ...],
    np.index_exp[1:, 1:, ...],
    np.index_exp[-1:, 1:, ...],
    np.index_exp[-2:, 1:, ...],
    np.index_exp[0:, -1:, ...],
    np.index_exp[1:, -1:, ...],
    np.index_exp[-1:, -1:, ...],
    np.index_exp[-2:, -1:, ...],
    np.index_exp[0:, -2:, ...],
    np.index_exp[1:, -2:, ...],
    np.index_exp[-1:, -2:, ...],
    np.index_exp[-2:, -2:, ...],
    np.index_exp[0:, 0:, 0:],
    np.index_exp[1:, 0:, 0:],
    np.index_exp[-1:, 0:, 0:],
    np.index_exp[-2:, 0:, 0:],
    np.index_exp[0:, 1:, 0:],
    np.index_exp[1:, 1:, 0:],
    np.index_exp[-1:, 1:, 0:],
    np.index_exp[-2:, 1:, 0:],
    np.index_exp[0:, -1:, 0:],
    np.index_exp[1:, -1:, 0:],
    np.index_exp[-1:, -1:, 0:],
    np.index_exp[-2:, -1:, 0:],
    np.index_exp[0:, -2:, 0:],
    np.index_exp[1:, -2:, 0:],
    np.index_exp[-1:, -2:, 0:],
    np.index_exp[-2:, -2:, 0:],
    np.index_exp[0:, 0:, 1:],
    np.index_exp[1:, 0:, 1:],
    np.index_exp[-1:, 0:, 1:],
    np.index_exp[-2:, 0:, 1:],
    np.index_exp[0:, 1:, 1:],
    np.index_exp[1:, 1:, 1:],
    np.index_exp[-1:, 1:, 1:],
    np.index_exp[-2:, 1:, 1:],
    np.index_exp[0:, -1:, 1:],
    np.index_exp[1:, -1:, 1:],
    np.index_exp[-1:, -1:, 1:],
    np.index_exp[-2:, -1:, 1:],
    np.index_exp[0:, -2:, 1:],
    np.index_exp[1:, -2:, 1:],
    np.index_exp[-1:, -2:, 1:],
    np.index_exp[-2:, -2:, 1:],
    np.index_exp[0:, 0:, -1:],
    np.index_exp[1:, 0:, -1:],
    np.index_exp[-1:, 0:, -1:],
    np.index_exp[-2:, 0:, -1:],
    np.index_exp[0:, 1:, -1:],
    np.index_exp[1:, 1:, -1:],
    np.index_exp[-1:, 1:, -1:],
    np.index_exp[-2:, 1:, -1:],
    np.index_exp[0:, -1:, -1:],
    np.index_exp[1:, -1:, -1:],
    np.index_exp[-1:, -1:, -1:],
    np.index_exp[-2:, -1:, -1:],
    np.index_exp[0:, -2:, -1:],
    np.index_exp[1:, -2:, -1:],
    np.index_exp[-1:, -2:, -1:],
    np.index_exp[-2:, -2:, -1:],
    np.index_exp[0:, 0:, -2:],
    np.index_exp[1:, 0:, -2:],
    np.index_exp[-1:, 0:, -2:],
    np.index_exp[-2:, 0:, -2:],
    np.index_exp[0:, 1:, -2:],
    np.index_exp[1:, 1:, -2:],
    np.index_exp[-1:, 1:, -2:],
    np.index_exp[-2:, 1:, -2:],
    np.index_exp[0:, -1:, -2:],
    np.index_exp[1:, -1:, -2:],
    np.index_exp[-1:, -1:, -2:],
    np.index_exp[-2:, -1:, -2:],
    np.index_exp[0:, -2:, -2:],
    np.index_exp[1:, -2:, -2:],
    np.index_exp[-1:, -2:, -2:],
    np.index_exp[-2:, -2:, -2:],
    np.index_exp[:, 1],
    np.index_exp[:, 1, :],
    np.index_exp[1, :],
    np.index_exp[1, :, :],
    np.index_exp[:, :, 1],
    np.index_exp[:, 1],
    np.index_exp[0:1, 1, 1:],
    np.index_exp[1, 0:1, 1:],
    np.index_exp[0:1, 1:, 1],
    np.index_exp[1, 0:1, 1],
    np.index_exp[:3, 1, 3:],
    np.index_exp[3, 3, 3:],
]

slices = [
    slice(None, None, None),
    slice(None, 1, None),
    slice(None, -1, None),
    slice(None, -2, None),
    slice(0, 1, None),
    slice(0, -1, None),
    slice(0, -2, None),
    slice(1, -1, None),
    slice(1, -2, None),
    slice(-2, -1, None),
    slice(0, 1, 1),
    slice(0, -1, 1),
    slice(0, -2, 1),
    slice(1, -1, 1),
    slice(1, -2, 1),
    slice(-2, -1, 1),
    slice(0, 1, 1),
    slice(0, -2, 1),
    slice(1, -1, 1),
    slice(1, -2, 1),
    slice(-2, -1, 1),
]

tuples = [
    (-2,),
    (-1,),
    (1,),
    (0,),
    (1, 0),
    (-1, -1),
    (-1, -2),
    (-2, -1),
    (-2, -2),
    (-1, 1),
    (-2, 1),
    (0, -2),
    (0, -1),
    (0, 1),
    (-1, 0),
    (-2, 0),
    (0, 0),
    (1, 1),
    (1, -1),
    (1, -2),
    (0, -1, -1),
    (0, -2, -1),
    (-1, 1, -1),
    (-2, 1, -1),
    (0, -1, 1),
    (0, -2, 1),
    (-1, 1, 1),
    (-2, 1, 1),
    (0, -1, -2),
    (0, -2, -2),
    (1, -1, 1),
    (1, -2, 1),
    (-2, -2, -2),
    (1, -1, -1),
    (1, -2, -1),
    (1, -1, -2),
    (1, -2, -2),
    (0, 0, -1),
    (0, 0, -2),
    (0, 0, 1),
    (1, 0, 1),
    (1, 0, -1),
    (-1, -1, -1),
    (-1, -1, 1),
    (-1, -2, 1),
    (-2, -1, 1),
    (-2, -2, 1),
    (1, 1, -2),
    (-1, -2, -1),
    (-2, -1, -1),
    (-2, -2, -1),
    (-1, -1, -2),
    (-1, -2, -2),
    (-2, -1, -2),
    (-1, 0, 1),
    (-2, 0, 1),
    (-1, 0, -1),
    (-2, 0, -1),
    (-1, 0, -2),
    (-1, 1, -2),
    (-2, 0, -2),
    (-2, 1, -2),
    (0, 1, -1),
    (0, 1, -2),
    (0, 1, 1),
    (1, 0, -2),
    (1, 1, -1),
    (1, 1, 1),
]

ints = [0, 1, -1, -2]
misc = [...]

valid_index_exp_params = misc + np_index_exp_params + slices + tuples + ints

invalid_index_params = [
    np.index_exp[0:0, 1],
    np.index_exp[:, 1:1:1],
    np.index_exp[True],
    np.index_exp[False],
    np.index_exp[None],
    (None,),
    (
        None,
        None,
    ),
    (
        1,
        None,
    ),
    (
        None,
        1,
    ),
    (None, None, None),
    (None, 1, None),
    (1, None, None),
    (None, None, 1),
    (1, 1, None),
    (None, 1, 1),
    (1, None, 1),
    (True,),
    (
        True,
        True,
    ),
    (
        True,
        1,
    ),
    (
        1,
        True,
    ),
    (
        True,
        True,
        True,
    ),
    (False,),
    (
        False,
        False,
    ),
    (
        False,
        1,
    ),
    (
        1,
        False,
    ),
    (
        False,
        False,
        False,
    ),
    (
        True,
        False,
        False,
    ),
    (
        True,
        True,
        False,
    ),
    (
        True,
        False,
        True,
    ),
    (
        False,
        True,
        False,
    ),
    (
        False,
        True,
        True,
    ),
    (
        False,
        True,
    ),
    (
        True,
        False,
    ),
    (False, True, 1),
    (True, False, 1),
    (
        1,
        False,
        True,
    ),
    (
        1,
        True,
        False,
    ),
    (
        False,
        1,
        True,
    ),
    (
        True,
        1,
        False,
    ),
    (
        True,
        False,
        None,
    ),
    (
        False,
        True,
        None,
    ),
    (
        1,
        False,
        None,
    ),
    (
        1,
        True,
        None,
    ),
    (
        True,
        None,
        False,
    ),
    (
        False,
        None,
        True,
    ),
    (
        True,
        None,
        1,
    ),
    (
        False,
        None,
        1,
    ),
    (
        None,
        True,
        False,
    ),
    (
        None,
        False,
        True,
    ),
    (
        None,
        1,
        False,
    ),
    (
        None,
        1,
        True,
    ),
    np.index_exp[:, :, :, :],
    np.index_exp[..., ...],
    np.index_exp[0, :, :, :],
    np.index_exp[:, 0, :, :],
    np.index_exp[:, :, 0, :],
    np.index_exp[:, :, :, 0],
    np.index_exp[..., 0, :, :],
    np.index_exp[0, ..., :, :],
    np.index_exp[0, :, ..., :],
    np.index_exp[0, :, :, ...],
    np.index_exp[0, 0, :, :],
    np.index_exp[0, :, 0, :],
    np.index_exp[0, :, :, 0],
    np.index_exp[:, 0, 0, :],
    np.index_exp[:, 0, :, 0],
    np.index_exp[:, :, 0, 0],
    np.index_exp[0, 0, :, ...],
    np.index_exp[0, 0, ..., :],
    np.index_exp[0, ..., 0, :],
    np.index_exp[..., 0, 0, :],
    np.index_exp[:, 0, 0, ...],
    np.index_exp[0, :, 0, ...],
    np.index_exp[0, :, ..., 0],
    np.index_exp[0, 0, 0, :],
    np.index_exp[0, 0, :, 0],
    np.index_exp[0, :, 0, 0],
    np.index_exp[:, 0, 0, 0],
    np.index_exp[1, 0, 0, 1],
    np.index_exp[-1, -1, -1, -1],
    np.index_exp[0:1, :, :, :],
    np.index_exp[1:, :, :, :],
    np.index_exp[-1:, :, :, :],
    slice(None, 0, None),
    slice(0, 0, None),
    slice(1, 0, None),
    slice(1, 1, None),
    slice(-1, 0, None),
    slice(-1, 1, None),
    slice(-1, -1, None),
    slice(-1, -2, None),
    slice(-2, 0, None),
    slice(-2, 1, None),
    slice(-2, -2, None),
    slice(0, 0, 1),
    slice(1, 0, 1),
    slice(1, 1, 1),
    slice(-1, 0, 1),
    slice(-1, 1, 1),
    slice(-1, -1, 1),
    slice(-1, -2, 1),
    slice(-2, 0, 1),
    slice(-2, 1, 1),
    slice(-2, -2, 1),
    slice(0, 0, 1),
    slice(1, 0, 1),
    slice(1, 1, 1),
    slice(-1, 0, 1),
    slice(-1, 1, 1),
    slice(-1, -1, 1),
    slice(-1, -2, 1),
    slice(-2, 0, 1),
    slice(-2, 1, 1),
    slice(-2, -2, 1),
]
